;------------------------------------------------------------
;      Jintori8x8
;------------------------------------------------------------
           start   @oser
;------------------------------------------------------------
PB1000:    EQU     1                   ;PB-1000 (Bit0)
PB1000C:   EQU     2                   ;PB-1000C(Bit1)
FX870P:    EQU     4                   ;FX-870P (Bit2)
AI1000:    EQU     8                   ;Ai-1000 (Bit3)
VX3:       EQU    16                   ;VX-3    (Bit4)
;------------------------------------------------------------
MODEL:     EQU     VX3                 ;p@
;------------------------------------------------------------
; VXe[NGA`
#if (MODEL&(PB1000+PB1000C))
; ###### PB-1000/CʃVXe` ######
dotds:     equ     &h022c              ;LCDĕ\
outac:     equ     &hff9e              ;P\
beep:      equ     &hffe5              ;BEEP
outdv:     equ     &h690c              ;o̓foCX(0:LCD)
edcsr:     equ     &h68c8              ;J[\ʒu
lcdtp:     equ     &h6201              ;LCD擪AhX
base:      equ     &h7000              ;start address
#if (MODEL=PB1000)
; ###### PB-1000 BIOSR[ ######
inkey:     equ     &h9e3b              ;INKEY$
#else
; ###### PB-1000C BIOSR[ ######
inkey:     equ     &h9f55              ;INKEY$
#endif
#endif
#if (MODEL=FX870P)
; ##### FX-870P/VX-4pVXe` #####
dotds:     equ     &h930f              ;LCDĕ\
outac:     equ     &h2af1              ;P\
inkey:     equ     &h191d              ;INKEY$
beep:      equ     &h33ba              ;BEEP
cls:       equ     &h9338              ;ʏ
outdv:     equ     &h1739              ;o̓foCX(0:LCD)
edcsr:     equ     &h1101              ;J[\ʒu
lcdtp:     equ     &h123c              ;LCD擪AhX
bios:      equ     &h5321              ;BIOSR[
base:      equ     &h1cd0              ;start address(FX870P)
#endif
#if (MODEL=AI1000)
; ##### AI-1000pVXe` #####
dotds:     equ     &h29fe              ;LCDĕ\
outac:     equ     &h41c6              ;P\
inkey:     equ     &h2711              ;INKEY$
beep:      equ     &h400f              ;BEEP
cls:       equ     &h41b0              ;ʏ
outdv:     equ     &h0abd              ;o̓foCX(0:LCD)
edcsr:     equ     &h08cb              ;J[\ʒu
lcdtp:     equ     &h0201              ;LCD擪AhX
bios:      equ     &h9881              ;BIOSR[
base:      equ     &h1000              ;start address(AI-1000)
#endif
#if (MODEL=VX3)
; ##### VX-3pVXe` #####
dotds:     equ     &h1fd5              ;LCDĕ\
outac:     equ     &h31e1              ;P\
inkey:     equ     &h194e              ;INKEY$
beep:      equ     &h3a8b              ;BEEP
cls:       equ     &h31cf              ;ʏ
outdv:     equ     &h6732              ;o̓foCX(0:LCD)
edcsr:     equ     &h6101              ;J[\ʒu
lcdtp:     equ     &h6343              ;LCD擪AhX
bios:      equ     &h5ca7              ;BIOSR[
base:      equ     &h6cd0              ;start address(VX-3)
#endif
           org     base                ;TOP

;""  
           db      &he0
           db      &ha0
           db      &he0
           db      &h00
;"+"  
           org     base+4
           db      &h40
           db      &he0
           db      &h40
           db      &h00
           org     base+&h08
           ds      8

           org     base+&h10
           ds      64

           org     base+&h50
; 8*8   ֳ dummy area
           db      &h00
;  ճ ޭݲ 1/8  ò
; 1234
;  567
;   89
;    0
           org     base+&h51
           db      10
           db      3
           db      2
           db      7
           db      5
           db      9
           db      6
           db      4
           db      8
           db      1
           org     base+&h5b
           ds      64

           org     base+&h9b
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
beepd:     db   0                      ;BEEPpWX^ۑGA
#endif
; game  ݺ (start to end)
@oser:
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           ldw     $28,cls             ; clear display
           cal     rcs

           gst     pd,$0               ;BEEPpf[^o
           an      $0,&h3f             ;
           or      $0,&h40             ;
           ldw     $2,beepd            ;
           st      $0,($2)             ;
#endif
           phuw    $1
           phuw    $3
           phuw    $5
           phuw    $27
           pre     ix,base+&h08
           ld      $26,6
           ld      $27,7
           cal     @clea
           cal     @grap
           cal     @init
           cal     @snap
           cal     @line
           st      $26,(ix+6)
           cal     @edcs
           ld      $0,$30
           st      $0,(ix+2)
           cal     @guid
           ld      $1,2
           st      $1,(ix+$31)
           ld      $1,3
           st      $1,(ix+$30)
           cal     @curs
           cal     @beep
           cal     @stat
           ldw     $2,(ix+$26)
           ld      $1,($2)
           ld      $4,&h02
           ld      $5,$4
oser1:     ld      $2,$4
           ld      $4,$5
           ld      $5,$2
           st      $26,(ix+6)
           cal     @edcs
           cal     @guid
oser2:     st      $1,(ix+6)
           cal     @aloc
           cal     @beep
           cal     @gput
           cal     @snap
           cal     @bide
           ld      $2,(ix+6)
           sbb     $5,$2
           adb     $4,$2
           adb     $4,$30
           st      $4,(ix+6)
           cal     @issu
           cmp     $0
           st      $0,(ix+2)
           st      $5,(ix+6)
           cal     @issu
           cal     @pasc
           sbc     (ix+6),$31
           jr      nz,oser1
           cmp     $0
           st      $0,(ix+2)
           cal     @pasc
           sbc     (ix+6),$31
           jr      nz,oser2
           ppuw    $26
           ppuw    $4
           ppuw    $2
           ppuw    $0
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           pst     ua,&h54
#endif
           rtn
; Ŷ  4      
@init:     phuw    $1
           phuw    $3
           ld      $0,3
           st      $0,(ix+$31)
           st      $0,(ix+$30)
           st      $30,(ix+2)
           cal     @put
           ld      $1,&hff
           ld      $2,4
           st      $2,(ix+$31)
           st      $1,(ix+2)
           cal     @put
           st      $2,(ix+$30)
           st      $30,(ix+2)
           cal     @put
           st      $0,(ix+$31)
           st      $1,(ix+2)
           cal     @put
           ppuw    $2
           ppuw    $0
           rtn
;   ò  work area 
; ix+0 | x
;   +1 | y
;   +2 |  (:01,:ff,+:00)
@put:      phuw    $1
           phuw    $3
           cal     @stat
           ldw     $0,(ix+$26)
           ld      $2,(ix+2)
           st      $2,($0)
           ppuw    $2
           ppuw    $0
           rtn
; work area  address  
; ix+0   | x
; ix+1   | y
; ix+$26 | address
@stat:     phuw    $1
           phuw    $3
           phuw    $5
           ldw     $4,base+&h50
           ld      $0,(ix+$31)
           sbc     $0,8
           jr      nc,stat1
           ld      $2,(ix+$30)
           sbc     $2,8
           jr      nc,stat1
           ld      $1,$31
           diu     $2
           bid     $2
           ld      $3,$31
           ldw     $4,base+&h10
           adw     $4,$0
           adw     $4,$2
stat1:     stw     $4,(ix+$26)
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
; display      
; ix+0 | x
;   +1 | y
@disp:     phuw    $1
           phuw    $3
           phuw    $5
           phuw    $7
           phuw    $9
           cal     @stat
           ldw     $0,(ix+$26)
           ld      $2,($0)
           ldw     $0,base
           sbc     $2,$30
           jr      z,disp1
           ad      $0,4
disp1:     cal     @cood
           ld      $7,(ix+3)
           ld      $8,$7
           inv     $8
           ldw     $2,(ix+$26)
           adw     $2,$30
           gre     ix,$4
           pre     ix,$0
           gre     iz,$0
           pre     iz,$2
           ld      $2,3
disp3:     ld      $3,(ix+$2)
           anc     $7,&hf0
           jr      nz,disp2
           did     $3
disp2:     an      $3,$7
           ld      $6,(iz+$2)
           an      $6,$8
           or      $6,$3
           st      $6,(iz+$2)
           sb      $2,$30
           jr      nc,disp3
           pre     ix,$4
           pre     iz,$0
           ppuw    $8
           ppuw    $6
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
; display ram  address  
; ix+0 | x
;   +1 | y
;   +6 | address
@cood:     phuw    $1
           phuw    $3
           phuw    $5
           ldw     $0,lcdtp
           xrw     $2,$2
           ld      $2,(ix+$31)
           biuw    $2
           biuw    $2
           adw     $0,$2
           xrw     $2,$2
           ld      $4,(ix+$30)
           ld      $5,&hf0
           bid     $4
           jr      nc,cood1
           inv     $5
cood1:     st      $5,(ix+3)
           ld      $3,$4
           bidw    $3
           ad      $3,$4
           bidw    $3
           adw     $0,$2
           stw     $0,(ix+$26)
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
; lcd  display
; none
@dotd:     phuw    $1
           phuw    $3
           phuw    $5
           phuw    $7
           phuw    $9
           phuw    $11
           phuw    $13
           phuw    $15
           phuw    $17
           gre     ix,$16
#if (MODEL&(PB1000+PB1000C))
           cal     dotds
#endif
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           ldw     $28,dotds
           cal     rcs
#endif
           pre     ix,$16
           ppuw    $16
           ppuw    $14
           ppuw    $12
           ppuw    $10
           ppuw    $8
           ppuw    $6
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
; ް  clear
;  ż (01)
@clea:     phuw    $1
           phuw    $3
           ld      $0,(ix+2)
           st      $31,(ix+2)
           ldw     $1,(ix+$31)
           st      $27,(ix+$31)
clea1:     st      $27,(ix+$30)
clea2:     cal     @put
           sb      (ix+$30),$30
           jr      nc,clea2
           sb      (ix+$31),$30
           jr      nc,clea1
           st      $0,(ix+2)
           stw     $1,(ix+$31)
           ppuw    $2
           ppuw    $0
           rtn
; picture reverse
; ix+0 | x
;   +1 | y
@pcrv:     phuw    $1
           phuw    $3
           phuw    $5
           cal     @cood
           ldw     $0,(ix+$26)
           ld      $2,(ix+3)
           ld      $3,5
pcrv1:     ld      $4,($0)
           xr      $4,$2
           st      $4,($0)
           adw     $0,$30
           sb      $3,$30
           jr      nz,pcrv1
           cal     @dotd
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@curs:     phuw    $1
curs1:     cal     @pcrv
           cal     @kywt
           ld      $0,(ix+6)
           cal     @pcrv
           sbc     $0,13
           jr      z,curs6
           sbc     $0,112
           jr      z,curs6
           sbc     $0,30
           jr      nz,curs2
           sb      (ix+$30),$30
curs2:     sbc     $0,31
           jr      nz,curs3
           ad      (ix+$30),$30
curs3:     sbc     $0,29
           jr      nz,curs4
           sb      (ix+$31),$30
curs4:     sbc     $0,28
           jr      nz,curs5
           ad      (ix+$31),$30
curs5:     ld      $0,(ix+$31)
           an      $0,$27
           st      $0,(ix+$31)
           ld      $0,(ix+$30)
           an      $0,$27
           st      $0,(ix+$30)
           jr      curs1
curs6:     st      $0,(ix+6)
           ppuw    $0
           rtn
@kywt:     phuw    $1
           phuw    $3
           phuw    $5
           phuw    $7
           phuw    $9
           phuw    $16
           phuw    $18
#if (MODEL&(PB1000+PB1000C))
           gre     iz,$5
#endif
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           gre     ix,$5
#endif
           ldw     $7,15
kywt1:
#if (MODEL&(PB1000+PB1000C))
           cal     inkey
#endif
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           cal     @inkey
#endif
           sbc     $17,$31
           jr      z,kywt2
           sbw     $7,$30
           jr      nz,kywt1
           jr      kywt3
kywt2:
#if (MODEL&(PB1000+PB1000C))
           cal     inkey
#endif
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           cal     @inkey
#endif
           sbc     $17,$31
           jr      z,kywt2
kywt3:     ld      $0,($15)

#if (MODEL&(PB1000+PB1000C))
           pre     iz,$5
#endif
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           pre     ix,$5
#endif
           st      $0,(ix+6)
           ppuw    $17
           ppuw    $15
           ppuw    $8
           ppuw    $6
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
@inkey:
           phuw    $6
           ldw     $28,inkey
           cal     rcs
           ppuw    $5
           rtn
#endif

@gput:     phuw    $1
           phuw    $3
           phuw    $5
           ld      $0,$31
           cal     @stat
           ldw     $1,(ix+$26)
           ld      $3,($1)
           sbc     $3,$31
           jr      nz,gput4
           ld      $1,&hff
           ld      $4,$1
gput1:     ld      $5,$1
gput2:     orc     $4,$5
           jr      z,gput3
           st      $4,(ix+4)
           st      $5,(ix+5)
           cal     @ckrv
           sbc     (ix+6),$31
           jr      z,gput3
           cal     @rvkm
           ld      $2,(ix+6)
           ad      $0,$2
gput3:     ad      $5,$30
           sbc     $5,2
           jr      nz,gput2
           ad      $4,$30
           sbc     $4,2
           jr      nz,gput1
           sbc     $0,$31
           cal     nz,@put
gput4:     st      $0,(ix+6)
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@ckrv:     phuw    $1
           phuw    $3
           phuw    $5
           phuw    $7
           phuw    $9
           ld      $0,(ix+$31)
           ld      $1,(ix+$30)
           ld      $2,(ix+4)
           ld      $3,(ix+5)
           ld      $8,$31
           ad      (ix+$31),$2
           ad      (ix+$30),$3
           cal     @stat
           ldw     $4,(ix+$26)
           ld      $6,($4)
           ld      $7,(ix+2)
           cmp     $7
           sbc     $6,$7
           jr      nz,ckrv2
ckrv1:     ad      $8,$30
           ad      (ix+$31),$2
           ad      (ix+$30),$3
           cal     @stat
           ldw     $4,(ix+$26)
           ld      $6,($4)
           sbc     $6,$7
           jr      z,ckrv1
           sbc     $6,$31
           jr      nz,ckrv2
           ld      $8,$31
ckrv2:     st      $8,(ix+6)
           st      $0,(ix+$31)
           st      $1,(ix+$30)
           ppuw    $8
           ppuw    $6
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@rvkm:     phuw    $1
           phuw    $3
           phuw    $5
           phuw    $7
           phuw    $9
           ld      $0,(ix+$31)
           ld      $1,(ix+$30)
           ld      $2,(ix+2)
           ld      $3,(ix+4)
           ld      $4,(ix+5)
           ld      $8,$31
rvkm1:     ad      (ix+$31),$3
           ad      (ix+$30),$4
           cal     @stat
           ldw     $5,(ix+$26)
           ld      $7,($5)
           cmp     $7
           sbc     $7,$2
           jr      nz,rvkm2
           cal     @put
           ad      $8,$30,jr rvkm1
rvkm2:     st      $0,(ix+$31)
           st      $1,(ix+$30)
           st      $8,(ix+6)
           ppuw    $8
           ppuw    $6
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
; beep  Ħ ޽
@beep:     phuw    $1
           phuw    $3
           phuw    $5
#if (MODEL&(PB1000+PB1000C))
           cal     beep
#endif
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
#if 1
;######### ZBEEP #########
           ldw     $2,beepd            ;
           ld      $0,($2)             ;
           ld      $3,20
beeplp:
           pst     pd,$0
           xr      $0,&hc0
           ld      $2,40
wait:      sb      $2,$30
           jr      nz,wait
           sb      $3,$30
           jr      nz,beeplp
#else
;######### BEEP0(BIOS) #########
           ldw     $28,beep
           cal     rcs
#endif
#endif
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@pasc:     phuw    $1
           phuw    $3
           phuw    $5
           ldw     $4,(ix+$31)
           ld      $0,7
           ld      $1,$0
pasc1:     ld      $2,$0
           st      $1,(ix+$31)
pasc2:     st      $2,(ix+$30)
           cal     @ptck
           ld      $3,(ix+6)
           sbc     $3,$31
           jr      nz,pasc3
           sb      $2,$30
           jr      nc,pasc2
           sb      $1,$30
           jr      nc,pasc1
pasc3:     st      $3,(ix+6)
           stw     $4,(ix+$31)
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@ptck:     phuw    $1
           phuw    $3
           phuw    $5
           cal     @stat
           ldw     $0,(ix+$26)
           ld      $2,($0)
           an      $2,&h01
           sb      $2,$30
           jr      z,ptck4
           ld      $2,$31
           ld      $3,&hff
           ld      $0,$3
ptck1:     ld      $1,$3
           st      $0,(ix+4)
ptck2:     st      $1,(ix+5)
           orc     $0,$1
           jr      z,ptck3
           cal     @ckrv
           ld      $4,(ix+6)
           ad      $2,$4
ptck3:     ad      $1,$30
           sbc     $1,2
           jr      nz,ptck2
           ad      $0,$30
           sbc     $0,2
           jr      nz,ptck1
ptck4:     st      $2,(ix+6)
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@line:     phuw    $1
           phuw    $3
           phuw    $5
           st      $31,(ix+$31)
           st      $31,(ix+$30)
           cal     @cood
           ldw     $0,(ix+$26)
           ldw     $2,33
           adw     $0,$2
           ldw     $2,191
           sbw     $0,$2
           gre     iz,$4
           pre     iz,$0
           ld      $0,&hff
           ld      $1,4
line1:     sti     $0,(iz+$2)
           sb      $1,$30
           jr      nz,line1
           pre     iz,$4
           cal     @dotd
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@grap:     phuw    $1
           phuw    $3
           phuw    $5
           ld      $4,&h10
           ld      $0,7
           st      $0,(ix+$31)
grap1:     st      $0,(ix+$30)
grap2:     cal     @cood
           ldw     $1,(ix+$26)
           adw     $1,$30
           adw     $1,$30
           ld      $3,&h40
           sbc     (ix+3),$4
           jr      nc,grap3
           did     $3
grap3:     ld      $5,($1)
           or      $5,$3
           st      $5,($1)
           sb      (ix+$30),$30
           jr      nc,grap2
           sb      (ix+$31),$30
           jr      nc,grap1
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@guid:     phuw    $1
           ld      $0,&hdb
           sbc     (ix+2),$30
           jr      z,guid1
           ld      $0,&h2b
guid1:     st      $31,(ix+6)
           cal     @odev
           st      $0,(ix+6)
           cal     @ochr
           ppuw    $0
           rtn
@ochr:     phuw    $1
           phuw    $3
           phuw    $5
           phuw    $7
           phuw    $9
           phuw    $11
           phuw    $13
           phuw    $15
           phuw    $17
           gre     iz,$14
           ld      $16,(ix+6)
#if (MODEL&(PB1000+PB1000C))
           cal     outac
#endif
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
           gre     ix,$2               ;ixۑ
           phuw    $3
           ldw     $28,outac           ;
           cal     rcs
           ppuw    $2
           pre     ix,$2               ;ixA
#endif
           pre     iz,$14
           ppuw    $16
           ppuw    $14
           ppuw    $12
           ppuw    $10
           ppuw    $8
           ppuw    $6
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@odev:
#if (MODEL&(PB1000+PB1000C))
           phuw    $1
           phuw    $3
           ld      $0,(ix+6)
           ldw     $1,outdv
           st      $0,($1)
           ppuw    $2
           ppuw    $0
#endif
           rtn
@edcs:     phuw    $1
           phuw    $3
           ld      $0,(ix+6)
           ldw     $1,edcsr
           st      $0,($1)
           ppuw    $2
           ppuw    $0
           rtn
@prio:     phuw    $1
           phuw    $3
           ldw     $0,(ix+$31)
           sbc     $1,$0
           jr      nc,prio1
           ld      $2,$0
           ld      $0,$1
           ld      $1,$2
prio1:     ld      $2,$27
           sb      $2,$0
           sbc     $2,$1
           jr      nc,prio2
           ld      $0,$27
           sb      $0,$1
           ld      $1,$2
prio2:     sbc     $1,4
           jr      c,prio3
           cmp     $1
           ad      $1,$27
prio3:     ad      $0,$1
           sb      $1,$30
           jr      nc,prio3
           gre     iz,$2
           pre     iz,base+&h51
           ld      $1,(iz+$0)
           pre     iz,$2
           st      $1,(ix+6)
           ppuw    $2
           ppuw    $0
           rtn
@reso:     phuw    $1
           phuw    $3
           phuw    $5
           ldw     $0,(ix+$26)
           ld      $2,$31
           ldw     $3,&h0808
           st      $27,(ix+$30)
reso1:     st      $27,(ix+$31)
reso2:     cal     @ptck
           sbc     (ix+6),$31
           jr      z,reso3
           cal     @prio
           sbc     (ix+6),$2
           jr      c,reso3
           ld      $2,(ix+6)
           ldw     $3,(ix+$31)
reso3:     sb      (ix+$31),$30
           jr      nc,reso2
           sb      (ix+$30),$30
           jr      nc,reso1
           stw     $0,(ix+$26)
           stw     $3,(ix+$31)
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@aloc:     phuw    $1
           ld      $0,(ix+6)
           sbc     (ix+2),$0
           jr      nz,aloc1
aloc2:     cal     @curs
           cal     @ptck
           sbc     (ix+6),$31
           jr      z,aloc2
           jr      aloc3
aloc1:     cal     @reso
aloc3:     ppuw    $0
           rtn
@issu:     phuw    $1
           phuw    $3
           ld      $0,(ix+2)
           ld      $3,(ix+6)
           ld      $1,6
           ad      $1,32
           sbc     $0,$30
           jr      z,issu1
           ad      $1,32
issu1:     st      $1,(ix+6)
           cal     @edcs
           cal     @guid
           didw    $3
           did     $2
           or      $3,&h30
           or      $2,&h30
           st      $3,(ix+6)
           cal     @ochr
           st      $2,(ix+6)
           cal     @ochr
           ppuw    $2
           ppuw    $0
           rtn
@coun:     phuw    $1
           phuw    $3
           phuw    $5
           ldw     $4,(ix+$31)
           ld      $0,&h00
           st      $27,(ix+$30)
coun1:     st      $27,(ix+$31)
coun2:     cal     @stat
           ldw     $1,(ix+$26)
           ld      $3,($1)
           ad      $3,$30
           sb      $3,$30
           ld      $3,&h00
           jr      z,coun3
           ld      $3,&h01
           jr      nc,coun3
           ld      $3,&h99
coun3:     adb     $0,$3
           sb      (ix+$31),$30
           jr      nc,coun2
           sb      (ix+$30),$30
           jr      nc,coun1
           st      $0,(ix+6)
           stw     $4,(ix+$31)
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@snap:     phuw    $1
           phuw    $3
           phuw    $5
           phuw    $7
           ldw     $0,(ix+$31)
           ldw     $5,(ix+$26)
           st      $27,(ix+$31)
snap1:     st      $27,(ix+$30)
snap2:     cal     @stat
           ldw     $2,(ix+$26)
           ld      $4,($2)
           sbc     $4,$31
           cal     nz,@disp
           sb      (ix+$30),$30
           jr      nc,snap2
           sb      (ix+$31),$30
           jr      nc,snap1
           cal     @dotd
           stw     $0,(ix+$31)
           stw     $5,(ix+$26)
           ppuw    $6
           ppuw    $4
           ppuw    $2
           ppuw    $0
           rtn
@bide:     phuw    $1
           ld      $0,(ix+6)
           ld      $1,&hff
bide1:     ad      $1,$30
           sb      $0,10
           jr      nc,bide1
           ad      $0,10
           diu     $1
           or      $0,$1
           st      $0,(ix+6)
           ppuw    $0
           rtn
@kadr:     phuw    $0
           ldw     $0,base+&h10
           stw     $0,(ix+$26)
           ppuw    $0
           rtn
@sadr:     phuw    $0
           ldw     $0,base+&h5b
           stw     $0,(ix+$26)
           ppuw    $0
           rtn
#if (MODEL=FX870P)|(MODEL=AI1000)|(MODEL=VX3)
; rom call system
rcs:       pst     ua,&h54
           jp      bios
#endif
